package filters;
import imagelab.*;

public class Contrast implements ImageFilter {

	//ImgProvider filteredImage = new ImgProvider();
	ImgProvider filteredImage;

public void filter (ImgProvider ip) {
	short tmp;
	short[][] im = ip.getBWImage();
	int min = im[0][0];
	int max = im[0][0];
	for (int r = 0; r<im.length; r++) {
		for (int c=0; c<im[0].length; c++) {
			if (im[r][c] < min) min = im[r][c];
			else if (im[r][c] > max) max = im[r][c];
		}//for c
	}//for r;
	double stretch = 256.0 / (max - min);

	for (int r = 0; r<im.length; r++) {
		for (int c=0; c<im[0].length; c++) {
			tmp = im[r][c];
			im[r][c] = (short)((double)(tmp - min)*stretch);
		}//for c
	}//for r;
	filteredImage = new ImgProvider();
	filteredImage.setBWImage(im);
	filteredImage.showPix("Contrast Enhanced");
}//filter

public ImgProvider getImgProvider() {
	return filteredImage;
}//getImgProvider

public String getMenuLabel() {
	return "Contrast(BW)";
} //getMenuLabel

}//Contrast class

