package filters;
import imagelab.*;

public class EdgeDetect implements ImageFilter {

	//ImgProvider filteredImage = new ImgProvider();
	ImgProvider filteredImage;

public void filter (ImgProvider ip) {
	short tmp;
	short[][] im = ip.getBWImage();
	short[][] im2 = new short[im.length][im[0].length];
	for (int r = 1; r<im.length-1; r++) {
		for (int c=1; c<im[0].length-1; c++) {
			int val = im[r][c];
			val *= 4;
			val -=  im[r-1][c];
			val -=  im[r+1][c];
			val -=  im[r][c-1];
			val -=  im[r][c+1];
			val /= 2;
			val = (val < 0) ? -val : val;
			if (val > 255) val = 255;
			im2[r][c] = (short)((val < 0) ? -val : val);
		}//for c
	}//for r;

	filteredImage = new ImgProvider();
	filteredImage.setBWImage(im2);
	filteredImage.showPix("Edges Detected");
}//filter

public ImgProvider getImgProvider() {
	return filteredImage;
}//getImgProvider

public String getMenuLabel() {
	return "Edge Detection(BW)";
} //getMenuLabel

}//Contrast class

