package filters;
import imagelab.*;
import javax.swing.JOptionPane;

public class Mesh implements ImageFilter {

	ImgProvider filteredImage;

public void filter (ImgProvider ip) {
	short tmp;
	short [][] al = ip.getAlpha();
	int npixels = getMeshSize();
	for (int r = 0; r<al.length; r++) {
		for (int c=0; c<al[0].length; c++) {
			if ((c/npixels+r/npixels) % 2 == 1) al[r][c] = 0;
		}//for c
	}//for r;
	filteredImage = new ImgProvider();
	filteredImage.setColors(ip.getRed(), ip.getGreen(), ip.getBlue(), al);
	filteredImage.showPix("Transparent");
}//filter

public ImgProvider getImgProvider() {
	return filteredImage;
}//getImgProvider

public String getMenuLabel() {
	return "Mesh";
} //getMenuLabel

protected int getMeshSize() {
	String response = JOptionPane.showInputDialog(null,  "Enter Mesh Size (1,2,4, or 8)", "");
	int num;
	try {
		num = Integer.parseInt(response);
		if (num <= 0) num = 2;
	} catch (NumberFormatException ex) {
		num = 2;
	}//catch
	return num;
}//getMeshSize

}


