package filters;
import imagelab.*;
import java.awt.*;
import javax.swing.*;
public class Mosaic implements ImageFilter {

	ImgProvider filteredImage;

public void filter (ImgProvider ip) {
	short tmp;
	short[][] red = ip.getRed();
	short[][] blue = ip.getBlue();
	short[][] green = ip.getGreen();
	short[][] alpha = ip.getAlpha();
	short[][] r2;
	short[][] g2;
	short[][] b2;
	short[][] a2;
	boolean [][] taken;
	int ewblocks = 10;			//number of blocks per row
	int nsblocks =  7;			//number of blocks per column

	ewblocks = Integer.parseInt(JOptionPane.showInputDialog("Number per row"));
	nsblocks = Integer.parseInt(JOptionPane.showInputDialog("Number of rows"));
	filteredImage = new ImgProvider();
	int nrows = blue.length - (blue.length % nsblocks);
	int ncols = blue[0].length - (blue[0].length%ewblocks);
	int blockWidth = ncols/ewblocks;
	int blockHeight = nrows/nsblocks;
	//System.out.println("nrows; " + nrows + ", ncols: " + ncols +
	//		",  blockwidth: " + blockWidth + ", blockHeight: " + blockHeight);
	taken = new boolean[blockHeight][blockWidth];
	int count = 0, nmoved = 0;
	r2 = new short[nrows][ncols];
	g2 = new short[nrows][ncols];
	b2 = new short[nrows][ncols];
	a2 = new short[nrows][ncols];
	while (nmoved < ewblocks*nsblocks && count < 1000) {
		count++;
		int row = (int)((nsblocks-0.5) * Math.random());
		int col = (int)((ewblocks-0.5) * Math.random());
		if (!taken[row][col]) {
			taken[row][col] = true;
			int blockr = nmoved / ewblocks;
			int blockc = nmoved % ewblocks;
			nmoved++;
			int frow = blockr * blockHeight;
			int fcol = blockc * blockWidth;
			int trow = row * blockHeight;
			int tcol = col * blockWidth;
			//System.out.println("("+frow+","+fcol+") --- ("+trow+","+tcol+")");
			for (int r=0; r<blockHeight; r++) {
				for (int c=0; c<blockWidth; c ++) {
					r2[r+trow][c+tcol]	= red[r+frow][c+fcol];
					g2[r+trow][c+tcol]	= green[r+frow][c+fcol];
					b2[r+trow][c+tcol]	= blue[r+frow][c+fcol];
					a2[r+trow][c+tcol]	= alpha[r+frow][c+fcol];
				}//for c
			}//for r
		}//if
	}//while
	filteredImage.setColors(r2, g2, b2, a2);
	filteredImage.showPix("Four Squares");
}//filter

public ImgProvider getImgProvider() {
	return filteredImage;
}//getImgProvider

public String getMenuLabel() {
	return "Mosaic";
} //getMenuLabel

}

