package imagelab;
import imagelab.*;

import java.awt.*;
import java.awt.image.*;
//import DisPanel;
//import WindowCloser;

public class DisplayImage extends Frame {

Image img;
private static int xspot = 50;		//location of subsequent windows changes
private static int yspot = 50;
private DisPanel pane;
protected ImgProvider improvider;	//ImgProvider that this object is activated by

/**
The constructor takes the Image object to display and a String to use as the title
of the window.
*/
public DisplayImage(ImgProvider imp, String title) {
	setTitle(title);
	setBackground(new Color(255,0,0,0));	//alpha of background set to 0 so
											//transparancy of displayed image will show
											//through to monitors background (thanks Jesse)
	improvider	= imp;
	img 		= imp.getImage();
	pane 		= new DisPanel(img);
	add(pane,"Center");
	int width;
	int height;
	while (-1 == (width = img.getWidth(null))) {
		//System.out.println("DisplayImage:constructor - first while");
		try {
				Thread.sleep(50);
			} catch (Exception e){}
	}

	while (-1 == (height = img.getHeight(null))) {
		//System.out.println("DisplayImage:constructor - second while");
		try {
				Thread.sleep(50);
			} catch (Exception e){}
	}
	if (xspot < 700) xspot += 50;
	else			 xspot = 50;
	if (yspot < 700) yspot += 40;
	else			 yspot = 50;
	setBounds(xspot,yspot,width,height+20); //+20 to allow room for title bar
	WindowCloser wc = new WindowCloser(this);
	this.addWindowListener(wc);
	//System.out.println("DisplayImage:constructor - calling show");
	show();
	//System.out.println("DisplayImage:constructor - back from calling show");
}//constructor

/** Notification that this window has become active */
public void setActive() {
	improvider.setActive();
}

}//class

